#pragma once

#include "public.sdk/source/vst2.x/audioeffectx.h"
#include <stdlib.h>
#include <string>
#include "Guiwrapper.h"
#include "Hoster.h"

class AWinamp : public AudioEffectX
{
public:
	AWinamp(audioMasterCallback audioMaster);
	~AWinamp(void);

	virtual void open ();
	virtual void close ();

	virtual void setBlockSize (VstInt32 blockSize);


	// Processing
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);

	// Program
	virtual void setProgramName (char* name);
	virtual void getProgramName (char* name);

	// Parameters
	virtual void setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void getParameterLabel (VstInt32 index, char* label);
	virtual void getParameterDisplay (VstInt32 index, char* text);
	virtual void getParameterName (VstInt32 index, char* text);

	virtual bool getEffectName (char* name);
	virtual bool getVendorString (char* text);
	virtual bool getProductString (char* text);
	virtual VstInt32 getVendorVersion ();

protected:
	void QuantizeAndInterlace(float *pinleft, float *pinright, short int *piout, int c);
	void DeQuantizeAndDeInterlace(short int *pin, float *poutleft,float *poutright, int c);
	
	Hoster* pHoster;
	short int* buffer;
	float fGain;
	int iBits;
	bool bStereo;
	char programName[kVstMaxProgNameLen + 1];


};
